<?php

init_plugins();

function &get_actions()
{
	global $actions;
	if (!isset($actions)) $actions = array();
	return $actions;
}

function add_action($action_type, $callback)
{
	$actions = &get_actions();
	if (isset($actions[$action_type]))
	{
		$list = &$actions[$action_type];
	}
	else
	{
		$list = array();
	}
	$data['context'] = context();
	$data['callback'] = $callback;
	$list[] = $data;
	$actions[$action_type] = $list;
}

function init_plugins()
{
	$dir = "plugins";
	$dh  = opendir($dir);
	$list = array();
    while (false !== ($filename = readdir($dh)))
    {
		if ($filename == "." || $filename == "..") continue;
        $r = sscanf($filename,"%s.php");
		// set current plugin id.	
		$plugin_id = $r[0];
		push_context($plugin_id);
		// initialize plugin
		include($dir."/".$filename);
		pop_context();
	}
}

function do_action($type)
{
	$actions = &get_actions();
	if (isset($actions[$type]))
	{
		$list = $actions[$type];
		foreach($list as $data)
		{
			$plugin_id = $data['context'];
			push_context($plugin_id);
			$callback = $data['callback'];
			$callback();
			pop_context();
		}
	}
}

function __($str)
{
	$plugin_id = context();
	if (isset($plugin_id)) 
		return "translation for plugin " . $plugin_id . " : $str<br/>";
	else 
		return "translation for platform or unknown plugin " . " : $str<br/>";
}

function push_context($context)
{
	global $context_stack;
	if (!isset($context_stack)) $context_stack = array();
	array_push($context_stack,$context);
}

function pop_context()
{
	global $context_stack;
	return array_pop($context_stack);
}

function context()
{
	global $context_stack;
	return $context_stack[count($context_stack)-1];
}
?>
